<template>
  <q-card style="border-radius: 50%; min-width: 4rem" :class="{ disabled }">
    <q-card-section class="q-pa-sm">
      <q-circular-progress
        :value="progress"
        size="3rem"
        style="position: relative"
        :color="circularProgressColor"
      />
      <Countdown
        style="
          position: absolute;
          top: 50%;
          left: 50%;
          transform: translate(-50%, -50%);
        "
        :time="endTime"
      />
    </q-card-section>
  </q-card>
</template>

<script lang="ts">
import Vue from "vue";
import Countdown from "./Countdown.vue";

export default Vue.extend({
  props: ["startTime", "endTime", "disabled"],
  methods: {
    zeroPad(num: number) {
      if (num >= 10) {
        return num;
      }
      return `0${num}`;
    },
  },
  data() {
    return {
      now: new Date(),
      timer: undefined as undefined | number,
    };
  },
  computed: {
    progress() {
      // Duration of the section
      const durationInMilliseconds = this.endTime - this.startTime;
      // Percentage of the way through the session
      const percent =
        (this.now.getTime() - this.startTime) / durationInMilliseconds;
      return percent * 100;
    },
    circularProgressColor() {
      if (this.disabled) return "grey";
      if (this.progress > 90) return "red";
      if (this.progress > 75) return "orange";
      if (this.progress > 50) return "yellow-8";
      return "green";
    },
  },
  created() {
    var self = this;
    this.timer = setInterval(function () {
      self.now = new Date();
    }, 1 * 1000);
  },
  beforeDestroy() {
    clearTimeout(this.timer);
  },
  components: { Countdown },
});
</script>
